set pitch 64.0
set press 64.0
set cont1 0.0
set cont2 64.0
set cont4 64.0
set cont11 127.0
set cont44 24.0
set cont411 0.0

proc myExit {} {
    global pitch
    puts stdout [format "NoteOff          0.0 1 %f 127" $pitch ]
    puts stdout [format "ExitProgram"]
    flush stdout
    exit
}

proc noteOn {pitchVal pressVal} {
    puts stdout [format "NoteOn           0.0 1 %f %f" $pitchVal $pressVal]
    flush stdout
}

proc noteOff {pitchVal pressVal} {
    puts stdout [format "NoteOff          0.0 1 %f %f" $pitchVal $pressVal]
    flush stdout
}

proc printWhatz {tag value1 value2 } {
    puts stdout [format "%s %i %f" $tag $value1 $value2]
    flush stdout
}

proc changePress {value} {
    global press
    set press $value
    puts stdout [format "AfterTouch       0.0 1 %f" $press]
    flush stdout
}

proc changePitch {value} {
    global pitch
    set pitch $value     
    puts stdout [format "PitchBend        0.0 1 %f" $pitch]
    flush stdout
}

. config -bg grey20

frame .left -bg grey20
frame .right -bg grey20

frame .plucked -bg black

button .plucked.on -text NoteOn -bg grey66 -command { noteOn $pitch $press }
button .plucked.off -text NoteOff -bg grey66 -command { noteOff $pitch 127.0 }
button .plucked.exit -text "Exit Program" -bg grey66 -command myExit

scale .left.pluckAmp -from 0 -to 128 -length 300 \
-variable press -command changePress \
-orient horizontal -label "Pluck Amplitude" \
-tickinterval 32 -showvalue true -bg grey66

scale .left.pitch -from 0 -to 128 -length 300 \
-command {changePitch }  -variable pitch \
-orient horizontal -label "MIDI Note Number" \
-tickinterval 32 -showvalue true -bg grey66

scale .left.vibrato -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 1} \
-orient horizontal -label "Mand Detune " \
-tickinterval 32 -showvalue true -bg grey66\
-variable cont1

scale .left.cont1 -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 2} \
-orient horizontal -label "Body Size" \
-tickinterval 32 -showvalue true -bg grey66 \
-variable cont2

scale .right.cont2 -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 4} \
-orient horizontal -label "Pick Position" \
-tickinterval 32 -showvalue true -bg grey66 \
-variable cont4

scale .right.cont3 -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 11} \
-orient horizontal -label "String Sustain" \
-tickinterval 32 -showvalue true -bg grey66 \
-variable cont11

scale .right.micNumber -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 128} \
-orient horizontal -label "Mic Position " \
-tickinterval 32 -showvalue true -bg grey66\
-variable cont411

scale .right.reverb -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 44} \
-orient horizontal -label "Reverb Mix " \
-tickinterval 32 -showvalue true -bg grey66\
-variable cont44

pack .plucked.on -side left -padx 5
pack .plucked.off -side left -padx 5
pack .plucked.exit -side left -padx 5
pack .plucked -pady 10
pack .left.pluckAmp 	-padx 10 -pady 5
pack .left.pitch 	-padx 10 -pady 5
pack .left.vibrato 	-padx 10 -pady 5
pack .left.cont1 	-padx 10 -pady 5
pack .left -side left
pack .right.cont2 	-padx 10 -pady 5
pack .right.cont3 	-padx 10 -pady 5
pack .right.micNumber -padx 10 -pady 5
pack .right.reverb -padx 10 -pady 5
pack .right -side left
bind all <KeyPress> {
    noteOn $pitch $press 
}
